<head>
    <h2 style="background-color: #495150; color: #FFFFFF; margin-bottom: -10px; font-family: Arial">ACD Hasci Demo</h2>
    <hr size="5" style="background-color: #ef7d00; color: #ef7d00">
</head>
<body>
    <label style="font-family: Arial">Status: </label>
    <label id="status" style="background-color:#d51130; color: #FFFFFF; font-family: Arial" >Disconnected</label>
    <br>
    <br>
    <button id="bindHasci" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Bind Data Service and Hasci</button>
    <button id="unbindHasci" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Unbind Data Service</button>
    <br>
    <br>
    <button id="triggerScan" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Scan</button>
    <br>
    <br>
    <label id="txtOutput" style="font-family: Arial"></label>
    <script language="javascript" type="text/javascript">

        const wsUri = "ws://127.0.0.1:56665/";
        
        var websocket;

        // UI variables
        var btnBindHasci;
        var btnUnbindHasci;
        var btnTriggerScan;
        var txtOutput;
        var txtStatus;

        // initialize the WebSocket connection to the WebAppService and setup the click listeners for the buttons 
        function init() {
            
            btnBindHasci = document.getElementById("bindHasci");
            btnUnbindHasci = document.getElementById("unbindHasci");
            btnTriggerScan = document.getElementById("triggerScan");
            txtOutput = document.getElementById("txtOutput");
            txtStatus = document.getElementById("status");

            writeToScreen("Scanned Data:");
            startWebSocket();

            btnBindHasci.onclick = function(){
                // send the bindHasci command to the WebAppService
                websocket.send("Hasci.bindDataService");
            };

            btnUnbindHasci.onclick = function(){
                // send the unbindHasci command to the WebAppService 
                websocket.send("Hasci.unbindDataService");
            };

            btnTriggerScan.onclick = function() {

                // define the parameters for the command
                const parameters = {
                    configCommand: "TRIGGER"
                };

                // send the TRIGGER config command with the parameters to the WebAppService
                websocket.send("Hasci.config." + JSON.stringify(parameters));
            };
        }

        // start the web socket connetion and react to incoming data
        function startWebSocket() {
            websocket = new WebSocket(wsUri);

            websocket.onopen = function(evt) {
                // enable the bindHasci button as soon as a connection to the web socket is established
                setButtonEnabled("bindHasci", true);
                txtStatus.textContent = "Scanner not bound";
                txtStatus.style = "background-color:#d51130; color: #FFFFFF; font-family: Arial"
            };

            websocket.onclose = function(evt) {
                // disable all buttons when the connection is closed
                setButtonEnabled("bindHasci", false);
                setButtonEnabled("unbindHasci", false);
                setButtonEnabled("triggerScan", false);
            };

            websocket.onmessage = function(evt) {
                //writeToScreen(evt.data);

                // parse received data sent by the WebAppService
                var message = evt.data;

                var hardwareComponent = message.split('.', 2)[0];
                var command = message.split('.', 2)[1];
                var rawdata = '';

                // separate the data using the substring function
                var dataStartPoint = hardwareComponent.length + command.length + 2;
                if (dataStartPoint < message.length) {
                    rawdata = message.substring(dataStartPoint, message.length)
                }

                try {
                    var data = JSON.parse(rawdata);
                    // hand the parsed data to the interpret data function 
                    interpretData(hardwareComponent, command, data);
                }
                catch (error) {
                    writeToScreen("failed to parse data: " + error);
                }
            };

            websocket.onerror = function(evt) {
                writeToScreen("Communication Error: " + event.message);
            };
        }

        function interpretData(hardwareComponent, command, data) {

            // since we only interpret Hasci data, we can pre-filter it here
            if (hardwareComponent == "Hasci") {
                if(!("error" in data)) {

                    // decide what to do on what command
                    switch(command) {
                        case "bindDataService":
                            // read the bound parameter if it exists
                            if ("bound" in data) {
                                if(data.bound) {
                                    setButtonEnabled("bindHasci", false);
                                    setButtonEnabled("unbindHasci", true);
                                    setButtonEnabled("triggerScan", true);

                                    websocket.send("Hasci.connectHasci");

                                    txtStatus.textContent = "Connected";
                                    txtStatus.style = "background-color:#76b72a; color: #FFFFFF; font-family: Arial"
                                }
                                else {
                                    writeToScreen("Error: failed to bind")
                                }
                            }
                            break;


                        case "scanData":
                            // read the scanData parameter if it exists
                            if ("scanData" in data) {
                                writeToScreen(data.scanData)
                            }
                            break;

                        case "unbindDataService":
                            // read the bound parameter if it exists
                            if ("bound" in data) {
                                if(!data.bound) {
                                    setButtonEnabled("bindHasci", true);
                                    setButtonEnabled("unbindHasci", false);
                                    setButtonEnabled("triggerScan", false);
                                    txtStatus.textContent = "Scanner not bound";
                                    txtStatus.style = "background-color:#d51130; color: #FFFFFF; font-family: Arial"
                                }
                                else {
                                    writeToScreen("Error: failed to unbind")
                                }
                            }
                            break;
                    }
                }
                else {
                    // if there is an error parameter, it will log it to the screen here
                    writeToScreen("Error in command " + command +": " + data.error);
                }
            }
        }

        // append a string to the txtOutput text field
        function writeToScreen(message) {
            var pre = document.createElement("p");
            pre.style.wordWrap = "break-word";
            pre.innerHTML = message;
            txtOutput.appendChild(pre);
        }

        function setButtonEnabled(buttonID, enabled) {
            if (enabled) {
                document.getElementById(buttonID).disabled = false;
                document.getElementById(buttonID).style = "background-color: #76b72a; color: #ffffff";
            }
            else {
                document.getElementById(buttonID).disabled = true;
                document.getElementById(buttonID).style = "background-color: #d2d4d5; color: #000000";
            }
        }

        // call the init function as soon as the window is loaded
        window.addEventListener("load", init, false);
        
    </script>
</body>